// Compiled by ClojureScript 1.7.122 {:elide-asserts true}
goog.provide('wryte.handlers');
goog.require('cljs.core');
goog.require('reagent.core');
goog.require('ajax.core');
goog.require('hickory.convert');
goog.require('clojure.zip');
goog.require('wryte.speech_recognition');
goog.require('tubax.core');
goog.require('goog.string');
goog.require('hickory.zip');
goog.require('cljs.test');
goog.require('wryte.db');
goog.require('tubax.helpers');
goog.require('goog.events');
goog.require('cljs.nodejs');
goog.require('hickory.select');
goog.require('hickory.core');
goog.require('clojure.string');
wryte.handlers.log = (function wryte$handlers$log(x){
return console.log(x);
});
wryte.handlers.remote = cljs.nodejs.require.call(null,"remote");
wryte.handlers.MENU = wryte.handlers.remote.require("menu");
wryte.handlers.MENUITEM = wryte.handlers.remote.require("menu-item");
wryte.handlers.stop_webspeech = (function wryte$handlers$stop_webspeech(){
wryte.db.set_checked_BANG_.call(null,false);

wryte.speech_recognition.stop_webspeech.call(null,cljs.core.deref.call(null,wryte.db.webspeech));

return wryte.db.set_recording_BANG_.call(null,false);
});
wryte.handlers.start_webspeech = (function wryte$handlers$start_webspeech(){
wryte.speech_recognition.start_webspeech.call(null,cljs.core.deref.call(null,wryte.db.webspeech));

return wryte.db.set_recording_BANG_.call(null,true);
});
/**
 * String Error -> String
 *   Consumes a String S and and associated Error, produces a new String with the
 *   Error corrected
 */
wryte.handlers.correct_error = (function wryte$handlers$correct_error(s,e){
var attr = new cljs.core.Keyword(null,"attributes","attributes",-74013604).cljs$core$IFn$_invoke$arity$1(e);
var row = (new cljs.core.Keyword(null,"fromy","fromy",-794847750).cljs$core$IFn$_invoke$arity$1(attr) | (0));
var col = (new cljs.core.Keyword(null,"fromx","fromx",346760477).cljs$core$IFn$_invoke$arity$1(attr) | (0));
var end = (new cljs.core.Keyword(null,"tox","tox",-20457648).cljs$core$IFn$_invoke$arity$1(attr) | (0));
var replacement = cljs.core.first.call(null,new cljs.core.Keyword(null,"replacements","replacements",1917839659).cljs$core$IFn$_invoke$arity$1(attr).split("#"));
var lines = clojure.string.split_lines.call(null,s);
var line = cljs.core.nth.call(null,lines,row);
var newline = [cljs.core.str(cljs.core.subs.call(null,line,(0),col)),cljs.core.str(replacement),cljs.core.str(cljs.core.subs.call(null,line,end))].join('');
var newlines = cljs.core.concat.call(null,cljs.core.conj.call(null,cljs.core.subvec.call(null,lines,(0),row),newline),cljs.core.subvec.call(null,lines,(row + (1))));
var result = clojure.string.join.call(null,"\n",newlines);
return result;
});
wryte.handlers.pos_at_line_helper = (function wryte$handlers$pos_at_line_helper(cv,los,c){
var newc = (c + (cljs.core.count.call(null,cljs.core.first.call(null,los)) + (1)));
if(cljs.core.empty_QMARK_.call(null,los)){
return cv;
} else {
return wryte$handlers$pos_at_line_helper.call(null,cljs.core.conj.call(null,cv,newc),cljs.core.rest.call(null,los),newc);
}
});
try{var values__19561__auto___26568 = cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0),(5),(9),(12)], null)),wryte.handlers.pos_at_line_helper.call(null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0)], null),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, ["1234","678","10"], null),(0)));
var result__19562__auto___26569 = cljs.core.apply.call(null,cljs.core._EQ_,values__19561__auto___26568);
if(cljs.core.truth_(result__19562__auto___26569)){
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"pass","pass",1574159993),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"pos-at-line-helper","pos-at-line-helper",-1539957763,null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0)], null),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, ["1234","678","10"], null),(0)),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0),(5),(9),(12)], null)),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core.cons.call(null,cljs.core._EQ_,values__19561__auto___26568),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
} else {
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"fail","fail",1706214930),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"pos-at-line-helper","pos-at-line-helper",-1539957763,null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0)], null),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, ["1234","678","10"], null),(0)),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0),(5),(9),(12)], null)),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,cljs.core.cons.call(null,new cljs.core.Symbol(null,"=","=",-1501502141,null),values__19561__auto___26568)),new cljs.core.Symbol(null,"not","not",1044554643,null)),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}

}catch (e26567){var t__19599__auto___26570 = e26567;
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"pos-at-line-helper","pos-at-line-helper",-1539957763,null),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0)], null),new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, ["1234","678","10"], null),(0)),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0),(5),(9),(12)], null)),new cljs.core.Keyword(null,"actual","actual",107306363),t__19599__auto___26570,new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}/**
 * String -> VecOfInt
 *   Consumes a String s and produces a accumulated ListOfInt with char count a
 *   beginning of line
 */
wryte.handlers.pos_at_line = (function wryte$handlers$pos_at_line(s){
var lines = clojure.string.split.call(null,s,/\n/);
return wryte.handlers.pos_at_line_helper.call(null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0)], null),lines,(0));
});
try{var values__19561__auto___26572 = cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0),(5),(9),(12)], null)),wryte.handlers.pos_at_line.call(null,"1234\n678\n10"));
var result__19562__auto___26573 = cljs.core.apply.call(null,cljs.core._EQ_,values__19561__auto___26572);
if(cljs.core.truth_(result__19562__auto___26573)){
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"pass","pass",1574159993),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"pos-at-line","pos-at-line",-1504946613,null),"1234\n678\n10"),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0),(5),(9),(12)], null)),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core.cons.call(null,cljs.core._EQ_,values__19561__auto___26572),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
} else {
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"fail","fail",1706214930),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"pos-at-line","pos-at-line",-1504946613,null),"1234\n678\n10"),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0),(5),(9),(12)], null)),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,cljs.core.cons.call(null,new cljs.core.Symbol(null,"=","=",-1501502141,null),values__19561__auto___26572)),new cljs.core.Symbol(null,"not","not",1044554643,null)),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}

}catch (e26571){var t__19599__auto___26574 = e26571;
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"pos-at-line","pos-at-line",-1504946613,null),"1234\n678\n10"),new cljs.core.PersistentVector(null, 4, 5, cljs.core.PersistentVector.EMPTY_NODE, [(0),(5),(9),(12)], null)),new cljs.core.Keyword(null,"actual","actual",107306363),t__19599__auto___26574,new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}wryte.handlers.loe1 = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"attributes","attributes",-74013604),new cljs.core.PersistentArrayMap(null, 8, [new cljs.core.Keyword(null,"fromy","fromy",-794847750),(0),new cljs.core.Keyword(null,"fromx","fromx",346760477),(7),new cljs.core.Keyword(null,"toy","toy",-1189798686),(0),new cljs.core.Keyword(null,"tox","tox",-20457648),(10),new cljs.core.Keyword(null,"replacements","replacements",1917839659),"Text#Test",new cljs.core.Keyword(null,"errorlength","errorlength",1388044786),(4),new cljs.core.Keyword(null,"context","context",-830191113),"Dast ist der Context",new cljs.core.Keyword(null,"contextoffset","contextoffset",1161979456),(2)], null)], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"attributes","attributes",-74013604),new cljs.core.PersistentArrayMap(null, 8, [new cljs.core.Keyword(null,"fromy","fromy",-794847750),(0),new cljs.core.Keyword(null,"fromx","fromx",346760477),(16),new cljs.core.Keyword(null,"toy","toy",-1189798686),(0),new cljs.core.Keyword(null,"tox","tox",-20457648),(20),new cljs.core.Keyword(null,"replacements","replacements",1917839659),"zwo#zwei",new cljs.core.Keyword(null,"errorlength","errorlength",1388044786),(4),new cljs.core.Keyword(null,"context","context",-830191113),"Dast ist der Context",new cljs.core.Keyword(null,"contextoffset","contextoffset",1161979456),(2)], null)], null),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"attributes","attributes",-74013604),new cljs.core.PersistentArrayMap(null, 8, [new cljs.core.Keyword(null,"fromy","fromy",-794847750),(0),new cljs.core.Keyword(null,"fromx","fromx",346760477),(29),new cljs.core.Keyword(null,"toy","toy",-1189798686),(0),new cljs.core.Keyword(null,"tox","tox",-20457648),(35),new cljs.core.Keyword(null,"replacements","replacements",1917839659),"",new cljs.core.Keyword(null,"errorlength","errorlength",1388044786),(6),new cljs.core.Keyword(null,"context","context",-830191113),"Dast ist der Context",new cljs.core.Keyword(null,"contextoffset","contextoffset",1161979456),(2)], null)], null)], null);
wryte.handlers.loe2 = new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"attributes","attributes",-74013604),new cljs.core.PersistentArrayMap(null, 6, [new cljs.core.Keyword(null,"fromy","fromy",-794847750),(0),new cljs.core.Keyword(null,"fromx","fromx",346760477),(5),new cljs.core.Keyword(null,"toy","toy",-1189798686),(0),new cljs.core.Keyword(null,"tox","tox",-20457648),(8),new cljs.core.Keyword(null,"replacements","replacements",1917839659),"mit",new cljs.core.Keyword(null,"errorlength","errorlength",1388044786),(3)], null)], null)], null);
wryte.handlers.s1 = "Dieser text hat Zwei Fehler. OnVista ist Testsieger.";
wryte.handlers.s2 = "Dieser Text hat zwo Fehler. OnVista ist Testsieger.";
wryte.handlers.s3 = "Text m\u00FCt\nAbsatz.";
wryte.handlers.los1 = new cljs.core.PersistentVector(null, 3, 5, cljs.core.PersistentVector.EMPTY_NODE, ["Dieser "," hat "," Fehler. OnVista ist Testsieger."], null);
wryte.handlers.los2 = new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, ["Text","zwo"], null);
wryte.handlers.los3 = new cljs.core.PersistentVector(null, 5, 5, cljs.core.PersistentVector.EMPTY_NODE, ["Dieser ","Text"," hat ","zwo"," Fehler. OnVista ist Testsieger."], null);
/**
 * String ListOfErrors ListOfInt Int Int -> ListOfString
 *   consume a string s and a ListOfErrors loe and ListOfInt with cummulated line-counts lp
 *   produces a ListOfString with s split a the errors (without the errors).
 */
wryte.handlers.split_at_errors = (function wryte$handlers$split_at_errors(s,loe,lp,start){
if(cljs.core.empty_QMARK_.call(null,loe)){
return cljs.core.cons.call(null,cljs.core.subs.call(null,s,start),loe);
} else {
var attr = new cljs.core.Keyword(null,"attributes","attributes",-74013604).cljs$core$IFn$_invoke$arity$1(cljs.core.first.call(null,loe));
var row = (new cljs.core.Keyword(null,"fromy","fromy",-794847750).cljs$core$IFn$_invoke$arity$1(attr) | (0));
var fromx = (new cljs.core.Keyword(null,"fromx","fromx",346760477).cljs$core$IFn$_invoke$arity$1(attr) | (0));
var tox = (new cljs.core.Keyword(null,"tox","tox",-20457648).cljs$core$IFn$_invoke$arity$1(attr) | (0));
var length = (new cljs.core.Keyword(null,"errorlength","errorlength",1388044786).cljs$core$IFn$_invoke$arity$1(attr) | (0));
var end = (cljs.core.nth.call(null,lp,row) + fromx);
var new_start = (end + length);
var word = cljs.core.subs.call(null,s,(cljs.core.nth.call(null,lp,row) + fromx),(((cljs.core.nth.call(null,lp,row) + fromx) + (1)) + length));
var replacement = cljs.core.first.call(null,new cljs.core.Keyword(null,"replacements","replacements",1917839659).cljs$core$IFn$_invoke$arity$1(attr).split("#"));
return cljs.core.cons.call(null,cljs.core.subs.call(null,s,start,end),wryte$handlers$split_at_errors.call(null,s,cljs.core.rest.call(null,loe),lp,new_start));
}
});
try{var values__19561__auto___26576 = cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,wryte.handlers.los1),wryte.handlers.split_at_errors.call(null,wryte.handlers.s1,wryte.handlers.loe1,wryte.handlers.pos_at_line.call(null,wryte.handlers.s1),(0)));
var result__19562__auto___26577 = cljs.core.apply.call(null,cljs.core._EQ_,values__19561__auto___26576);
if(cljs.core.truth_(result__19562__auto___26577)){
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"pass","pass",1574159993),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"split-at-errors","split-at-errors",1103730813,null),new cljs.core.Symbol(null,"s1","s1",338671490,null),new cljs.core.Symbol(null,"loe1","loe1",880840516,null),cljs.core.list(new cljs.core.Symbol(null,"pos-at-line","pos-at-line",-1504946613,null),new cljs.core.Symbol(null,"s1","s1",338671490,null)),(0)),new cljs.core.Symbol(null,"los1","los1",-305196518,null)),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core.cons.call(null,cljs.core._EQ_,values__19561__auto___26576),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
} else {
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"fail","fail",1706214930),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"split-at-errors","split-at-errors",1103730813,null),new cljs.core.Symbol(null,"s1","s1",338671490,null),new cljs.core.Symbol(null,"loe1","loe1",880840516,null),cljs.core.list(new cljs.core.Symbol(null,"pos-at-line","pos-at-line",-1504946613,null),new cljs.core.Symbol(null,"s1","s1",338671490,null)),(0)),new cljs.core.Symbol(null,"los1","los1",-305196518,null)),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,cljs.core.cons.call(null,new cljs.core.Symbol(null,"=","=",-1501502141,null),values__19561__auto___26576)),new cljs.core.Symbol(null,"not","not",1044554643,null)),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}

}catch (e26575){var t__19599__auto___26578 = e26575;
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"split-at-errors","split-at-errors",1103730813,null),new cljs.core.Symbol(null,"s1","s1",338671490,null),new cljs.core.Symbol(null,"loe1","loe1",880840516,null),cljs.core.list(new cljs.core.Symbol(null,"pos-at-line","pos-at-line",-1504946613,null),new cljs.core.Symbol(null,"s1","s1",338671490,null)),(0)),new cljs.core.Symbol(null,"los1","los1",-305196518,null)),new cljs.core.Keyword(null,"actual","actual",107306363),t__19599__auto___26578,new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}/**
 * ListOfErrors -> ListOfStrings
 *   Consumes a ListOfErrors and Produces the replecements if present
 */
wryte.handlers.corrections = (function wryte$handlers$corrections(loe){
var correction = (function (e){
var attr = new cljs.core.Keyword(null,"attributes","attributes",-74013604).cljs$core$IFn$_invoke$arity$1(e);
var context = new cljs.core.Keyword(null,"context","context",-830191113).cljs$core$IFn$_invoke$arity$1(attr);
var offset = (new cljs.core.Keyword(null,"contextoffset","contextoffset",1161979456).cljs$core$IFn$_invoke$arity$1(attr) | (0));
var length = (new cljs.core.Keyword(null,"errorlength","errorlength",1388044786).cljs$core$IFn$_invoke$arity$1(attr) | (0));
var word = clojure.string.lower_case.call(null,cljs.core.subs.call(null,context,offset,(offset + length)));
var replacement = cljs.core.first.call(null,new cljs.core.Keyword(null,"replacements","replacements",1917839659).cljs$core$IFn$_invoke$arity$1(attr).split("#"));
var alternatives = cljs.core.rest.call(null,clojure.string.split.call(null,new cljs.core.Keyword(null,"replacements","replacements",1917839659).cljs$core$IFn$_invoke$arity$1(attr),"#"));
var rule_id = new cljs.core.Keyword(null,"ruleId","ruleId",-177430189).cljs$core$IFn$_invoke$arity$1(attr);
if(cljs.core.contains_QMARK_.call(null,wryte.db.ignore_list.call(null),word)){
return [cljs.core.str("<span class='ignored' data-replaced='"),cljs.core.str(word),cljs.core.str("'>"),cljs.core.str(cljs.core.get.call(null,wryte.db.ignore_list.call(null),word)),cljs.core.str("</span>")].join('');
} else {
if((cljs.core._EQ_.call(null,rule_id,"UPPERCASE_SENTENCE_START")) || (cljs.core._EQ_.call(null,rule_id,"WHITESPACE_RULE"))){
return [cljs.core.str("<span class='uppercase-sentence-start' data-alternatives='"),cljs.core.str(cljs.core.clj__GT_js.call(null,alternatives)),cljs.core.str("' data-replaced='"),cljs.core.str(word),cljs.core.str("'>"),cljs.core.str(replacement),cljs.core.str("</span>")].join('');
} else {
if((cljs.core.count.call(null,replacement) > (0))){
return [cljs.core.str("<span class='error' data-alternatives='"),cljs.core.str(cljs.core.clj__GT_js.call(null,alternatives)),cljs.core.str("' data-replaced='"),cljs.core.str(word),cljs.core.str("'>"),cljs.core.str(replacement),cljs.core.str("</span>")].join('');
} else {
return [cljs.core.str("<span class='error' data-alternatives='"),cljs.core.str(cljs.core.clj__GT_js.call(null,alternatives)),cljs.core.str("' data-replaced='"),cljs.core.str(word),cljs.core.str("'>"),cljs.core.str(word),cljs.core.str("</span>")].join('');
}

}
}
});
return cljs.core.filter.call(null,((function (correction){
return (function (x){
return x;
});})(correction))
,cljs.core.map.call(null,correction,loe));
});
try{var values__19561__auto___26580 = cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,wryte.handlers.los2),wryte.handlers.corrections.call(null,wryte.handlers.loe1));
var result__19562__auto___26581 = cljs.core.apply.call(null,cljs.core._EQ_,values__19561__auto___26580);
if(cljs.core.truth_(result__19562__auto___26581)){
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"pass","pass",1574159993),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"corrections","corrections",1804444727,null),new cljs.core.Symbol(null,"loe1","loe1",880840516,null)),new cljs.core.Symbol(null,"los2","los2",839136464,null)),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core.cons.call(null,cljs.core._EQ_,values__19561__auto___26580),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
} else {
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"fail","fail",1706214930),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"corrections","corrections",1804444727,null),new cljs.core.Symbol(null,"loe1","loe1",880840516,null)),new cljs.core.Symbol(null,"los2","los2",839136464,null)),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,cljs.core.cons.call(null,new cljs.core.Symbol(null,"=","=",-1501502141,null),values__19561__auto___26580)),new cljs.core.Symbol(null,"not","not",1044554643,null)),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}

}catch (e26579){var t__19599__auto___26582 = e26579;
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"corrections","corrections",1804444727,null),new cljs.core.Symbol(null,"loe1","loe1",880840516,null)),new cljs.core.Symbol(null,"los2","los2",839136464,null)),new cljs.core.Keyword(null,"actual","actual",107306363),t__19599__auto___26582,new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}/**
 * ListOfString ListOfStrings -> ListOfStrings
 *   Produces a zipped ListOfString
 */
wryte.handlers.zip_corrections = (function wryte$handlers$zip_corrections(los1,los2){
if(cljs.core._EQ_.call(null,cljs.core.count.call(null,los1),cljs.core.count.call(null,los2))){
return cljs.core.interleave.call(null,los1,los2);
} else {
return cljs.core.conj.call(null,cljs.core.vec.call(null,cljs.core.interleave.call(null,los1,los2)),cljs.core.last.call(null,los1));
}
});
try{var values__19561__auto___26584 = cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,wryte.handlers.los3),wryte.handlers.zip_corrections.call(null,wryte.handlers.los1,wryte.handlers.los2));
var result__19562__auto___26585 = cljs.core.apply.call(null,cljs.core._EQ_,values__19561__auto___26584);
if(cljs.core.truth_(result__19562__auto___26585)){
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"pass","pass",1574159993),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"zip-corrections","zip-corrections",-1996807594,null),new cljs.core.Symbol(null,"los1","los1",-305196518,null),new cljs.core.Symbol(null,"los2","los2",839136464,null)),new cljs.core.Symbol(null,"los3","los3",-489832551,null)),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core.cons.call(null,cljs.core._EQ_,values__19561__auto___26584),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
} else {
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"fail","fail",1706214930),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"zip-corrections","zip-corrections",-1996807594,null),new cljs.core.Symbol(null,"los1","los1",-305196518,null),new cljs.core.Symbol(null,"los2","los2",839136464,null)),new cljs.core.Symbol(null,"los3","los3",-489832551,null)),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,cljs.core.cons.call(null,new cljs.core.Symbol(null,"=","=",-1501502141,null),values__19561__auto___26584)),new cljs.core.Symbol(null,"not","not",1044554643,null)),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}

}catch (e26583){var t__19599__auto___26586 = e26583;
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),cljs.core.list(new cljs.core.Symbol(null,"zip-corrections","zip-corrections",-1996807594,null),new cljs.core.Symbol(null,"los1","los1",-305196518,null),new cljs.core.Symbol(null,"los2","los2",839136464,null)),new cljs.core.Symbol(null,"los3","los3",-489832551,null)),new cljs.core.Keyword(null,"actual","actual",107306363),t__19599__auto___26586,new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}try{var values__19561__auto___26588 = cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,clojure.string.join.call(null,"",wryte.handlers.zip_corrections.call(null,wryte.handlers.los1,wryte.handlers.los2))),wryte.handlers.s2);
var result__19562__auto___26589 = cljs.core.apply.call(null,cljs.core._EQ_,values__19561__auto___26588);
if(cljs.core.truth_(result__19562__auto___26589)){
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"pass","pass",1574159993),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),new cljs.core.Symbol(null,"s2","s2",614604262,null),cljs.core.list(new cljs.core.Symbol(null,"join","join",881669637,null),"",cljs.core.list(new cljs.core.Symbol(null,"zip-corrections","zip-corrections",-1996807594,null),new cljs.core.Symbol(null,"los1","los1",-305196518,null),new cljs.core.Symbol(null,"los2","los2",839136464,null)))),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core.cons.call(null,cljs.core._EQ_,values__19561__auto___26588),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
} else {
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"fail","fail",1706214930),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),new cljs.core.Symbol(null,"s2","s2",614604262,null),cljs.core.list(new cljs.core.Symbol(null,"join","join",881669637,null),"",cljs.core.list(new cljs.core.Symbol(null,"zip-corrections","zip-corrections",-1996807594,null),new cljs.core.Symbol(null,"los1","los1",-305196518,null),new cljs.core.Symbol(null,"los2","los2",839136464,null)))),new cljs.core.Keyword(null,"actual","actual",107306363),cljs.core._conj.call(null,cljs.core._conj.call(null,cljs.core.List.EMPTY,cljs.core.cons.call(null,new cljs.core.Symbol(null,"=","=",-1501502141,null),values__19561__auto___26588)),new cljs.core.Symbol(null,"not","not",1044554643,null)),new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}

}catch (e26587){var t__19599__auto___26590 = e26587;
cljs.test.do_report.call(null,new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"type","type",1174270348),new cljs.core.Keyword(null,"error","error",-978969032),new cljs.core.Keyword(null,"expected","expected",1583670997),cljs.core.list(new cljs.core.Symbol(null,"=","=",-1501502141,null),new cljs.core.Symbol(null,"s2","s2",614604262,null),cljs.core.list(new cljs.core.Symbol(null,"join","join",881669637,null),"",cljs.core.list(new cljs.core.Symbol(null,"zip-corrections","zip-corrections",-1996807594,null),new cljs.core.Symbol(null,"los1","los1",-305196518,null),new cljs.core.Symbol(null,"los2","los2",839136464,null)))),new cljs.core.Keyword(null,"actual","actual",107306363),t__19599__auto___26590,new cljs.core.Keyword(null,"message","message",-406056002),null], null));
}/**
 * String ListOfErrors -> ListOfString
 *   consume a string s and a ListOfErrors loe and produces a ListOfString with
 *   s split a the errors (and the correction) in between the splits.
 */
wryte.handlers.correct_errors = (function wryte$handlers$correct_errors(s,loe){
var line_positions = wryte.handlers.pos_at_line.call(null,s);
var splits = wryte.handlers.split_at_errors.call(null,s,loe,line_positions,(0));
var corrected = wryte.handlers.corrections.call(null,loe);
var zipped = wryte.handlers.zip_corrections.call(null,splits,corrected);
cljs.core.println.call(null,zipped);

wryte.handlers.log.call(null,clojure.string.join.call(null,"",zipped));

return clojure.string.join.call(null,"",zipped);
});
/**
 * (String) Response -> Void
 *   Get's the response from languagetool and applys the result to fresult
 */
wryte.handlers.ltool_handler = (function wryte$handlers$ltool_handler(r){
var errors = tubax.helpers.find_all.call(null,tubax.core.xml__GT_clj.call(null,r),new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"tag","tag",-1290361223),new cljs.core.Keyword(null,"error","error",-978969032)], null));
var corrected_result = wryte.handlers.correct_errors.call(null,wryte.db.fresult__GT_string.call(null,wryte.db.fresult.call(null)),errors);
var e = cljs.core.print.call(null,[cljs.core.str("COR: "),cljs.core.str(corrected_result)].join(''));
var paragraphed = wryte.speech_recognition.newline__GT_paragraph.call(null,corrected_result);
var hiccuped = cljs.core.map.call(null,hickory.core.as_hiccup,hickory.core.parse_fragment.call(null,paragraphed));
wryte.handlers.log.call(null,[cljs.core.str("RESULT: "),cljs.core.str(r)].join(''));

cljs.core.println.call(null,"HICCUPED: ",hiccuped);

return cljs.core.println.call(null,"LTOOL-HANDLER: ",wryte.db.set_fresult_BANG_.call(null,cljs.core.vec.call(null,cljs.core.cons.call(null,new cljs.core.Keyword(null,"div","div",1057191632),hiccuped))));
});
wryte.handlers.ltool_error_handler = (function wryte$handlers$ltool_error_handler(){
return wryte.handlers.log.call(null,"Couldn't get response from languagetool.org");
});
/**
 * String -> Void
 *   Sends string to languagetool.org
 */
wryte.handlers.send_to_languagetool = (function wryte$handlers$send_to_languagetool(s){
wryte.handlers.log.call(null,[cljs.core.str("SEND: "),cljs.core.str(s)].join(''));

return ajax.core.GET.call(null,"https://languagetool.org:8081",new cljs.core.PersistentArrayMap(null, 4, [new cljs.core.Keyword(null,"params","params",710516235),new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"language","language",-1591107564),wryte.db.locale.call(null),new cljs.core.Keyword(null,"text","text",-1790561697),goog.string.urlEncode(s)], null),new cljs.core.Keyword(null,"handler","handler",-195596612),wryte.handlers.ltool_handler,new cljs.core.Keyword(null,"error-handler","error-handler",-484945776),wryte.handlers.ltool_error_handler,new cljs.core.Keyword(null,"b","b",1482224470),goog.string.urlEncode("enabled")], null));
});
wryte.handlers.toggle_recording_BANG_ = (function wryte$handlers$toggle_recording_BANG_(event){
if(cljs.core.truth_(wryte.db.recording_QMARK_.call(null))){
return wryte.handlers.stop_webspeech.call(null);
} else {
cljs.core.deref.call(null,wryte.db.webspeech).start();

return wryte.db.set_recording_BANG_.call(null,true);
}
});
/**
 * ListOfString Node Object Function -> Void
 *   Consumes a list of strings los, a Node el and adds each item of los
 *   to the delivered context menu with the click-handler Function f
 */
wryte.handlers.add_alternatives_BANG_ = (function wryte$handlers$add_alternatives_BANG_(los,el,menu,f){
if(cljs.core.empty_QMARK_.call(null,los)){
return true;
} else {
menu.append((new wryte.handlers.MENUITEM(cljs.core.clj__GT_js.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"label","label",1718410804),cljs.core.first.call(null,los),new cljs.core.Keyword(null,"click","click",1912301393),(function (){
return f.call(null,cljs.core.first.call(null,los),el);
})], null)))));

return wryte$handlers$add_alternatives_BANG_.call(null,cljs.core.rest.call(null,los),el,menu,f);
}
});
/**
 * String Node -> GlobalState
 *   Interchenges innerText of Node el with String w, replaces the GlobalState
 */
wryte.handlers.override_correction_BANG_ = (function wryte$handlers$override_correction_BANG_(w,el){
var c = el.innerText;
var replaced = el.dataset.replaced;
var alternatives = el.dataset.alternatives;
var fresult_hkr = cljs.core.first.call(null,hickory.convert.hiccup_fragment_to_hickory.call(null,new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [wryte.db.fresult.call(null)], null)));
var slt = hickory.select.select_locs.call(null,hickory.select.child.call(null,hickory.select.tag.call(null,new cljs.core.Keyword(null,"div","div",1057191632)),hickory.select.tag.call(null,new cljs.core.Keyword(null,"p","p",151049309)),hickory.select.and.call(null,hickory.select.attr.call(null,new cljs.core.Keyword(null,"data-replaced","data-replaced",1618336213),((function (c,replaced,alternatives,fresult_hkr){
return (function (p1__26591_SHARP_){
return cljs.core._EQ_.call(null,p1__26591_SHARP_,replaced);
});})(c,replaced,alternatives,fresult_hkr))
),hickory.select.attr.call(null,new cljs.core.Keyword(null,"data-alternatives","data-alternatives",-605188051),((function (c,replaced,alternatives,fresult_hkr){
return (function (p1__26592_SHARP_){
return cljs.core._EQ_.call(null,p1__26592_SHARP_,alternatives);
});})(c,replaced,alternatives,fresult_hkr))
),hickory.select.find_in_text.call(null,cljs.core.re_pattern.call(null,c)))),fresult_hkr);
var loc = cljs.core.first.call(null,slt);
var loc_el = cljs.core.first.call(null,loc);
var old_attrs = new cljs.core.Keyword(null,"attrs","attrs",-2090668713).cljs$core$IFn$_invoke$arity$1(loc_el);
var new_attrs = cljs.core.assoc.call(null,old_attrs,new cljs.core.Keyword(null,"data-alternatives","data-alternatives",-605188051),"",new cljs.core.Keyword(null,"class","class",-2030961996),"ignored");
var new_loc_el = cljs.core.assoc.call(null,loc_el,new cljs.core.Keyword(null,"attrs","attrs",-2090668713),new_attrs,new cljs.core.Keyword(null,"content","content",15833224),new cljs.core.PersistentVector(null, 1, 5, cljs.core.PersistentVector.EMPTY_NODE, [w], null));
var new_loc = clojure.zip.replace.call(null,loc,new_loc_el);
var new_fresult = hickory.convert.hickory_to_hiccup.call(null,clojure.zip.root.call(null,new_loc));
cljs.core.println.call(null,hickory.convert.hickory_to_hiccup.call(null,clojure.zip.root.call(null,new_loc)));

return wryte.db.set_fresult_BANG_.call(null,new_fresult);
});
/**
 * String String -> GlobalState
 *   Add the ignored String i with the replaced String r, returns the GlobalState
 */
wryte.handlers.add_to_ignore_list_BANG_ = (function wryte$handlers$add_to_ignore_list_BANG_(i,r){
wryte.db.add_to_ignore_BANG_.call(null,i,r);

return cljs.core.println.call(null,[cljs.core.str("IGNORE: "),cljs.core.str(wryte.db.ignore_list.call(null))].join(''));
});
wryte.handlers.on_click_dict_button = (function wryte$handlers$on_click_dict_button(event){
if(cljs.core._EQ_.call(null,wryte.db.edit_QMARK_.call(null),true)){
return wryte.db.set_edit_BANG_.call(null,false);
} else {
return null;
}
});
wryte.handlers.on_click_edit_button = (function wryte$handlers$on_click_edit_button(event){
if(cljs.core._EQ_.call(null,wryte.db.edit_QMARK_.call(null),false)){
wryte.db.set_edit_BANG_.call(null,true);

if(cljs.core.truth_(wryte.db.recording_QMARK_.call(null))){
return wryte.handlers.stop_webspeech.call(null);
} else {
return null;
}
} else {
return null;
}
});
wryte.handlers.on_click_start_button = (function wryte$handlers$on_click_start_button(event){
return wryte.handlers.toggle_recording_BANG_.call(null,event);
});
/**
 * Event -> Void
 *   Adds a colon to the dictation text
 */
wryte.handlers.on_click_colon = (function wryte$handlers$on_click_colon(event){
cljs.core.deref.call(null,wryte.db.webspeech).stop();

return wryte.db.set_colon_BANG_.call(null);
});
/**
 * Event -> Void
 *   Adds a colon to the dictation text
 */
wryte.handlers.on_click_comma = (function wryte$handlers$on_click_comma(event){
cljs.core.deref.call(null,wryte.db.webspeech).stop();

return wryte.db.set_comma_BANG_.call(null);
});
/**
 * Event -> Void
 *   Adds a colon to the dictation text
 */
wryte.handlers.on_click_dquote = (function wryte$handlers$on_click_dquote(event){
cljs.core.deref.call(null,wryte.db.webspeech).stop();

return wryte.db.set_dquote_BANG_.call(null);
});
/**
 * Event -> Void
 *   Adds a colon to the dictation text
 */
wryte.handlers.on_click_squote = (function wryte$handlers$on_click_squote(event){
cljs.core.deref.call(null,wryte.db.webspeech).stop();

return wryte.db.set_squote_BANG_.call(null);
});
/**
 * Event -> Void
 *   Adds a colon to the dictation text
 */
wryte.handlers.on_click_pgraph = (function wryte$handlers$on_click_pgraph(event){
cljs.core.deref.call(null,wryte.db.webspeech).stop();

return wryte.db.set_pgraph_BANG_.call(null);
});
/**
 * Event -> Void
 *   Sets the speech reconigtion and spell checking to German
 */
wryte.handlers.on_click_german = (function wryte$handlers$on_click_german(event){
cljs.core.println.call(null,wryte.db.language.call(null));

return wryte.db.set_language_BANG_.call(null,new cljs.core.Keyword(null,"german","german",1430985114));
});
/**
 * Event -> Void
 *   Sets the speech reconigtion and spell checking to English
 */
wryte.handlers.on_click_english = (function wryte$handlers$on_click_english(event){
cljs.core.println.call(null,wryte.db.language.call(null));

return wryte.db.set_language_BANG_.call(null,new cljs.core.Keyword(null,"english","english",1087501909));
});
/**
 * String Node -> Void
 *   Consumes the chosen word w and concerning element el and replaces the
 *   content of the element with w, additionally adds the chosen word to the
 *   ignore list with for content of the element
 */
wryte.handlers.on_click_context_menu_item = (function wryte$handlers$on_click_context_menu_item(w,el){
var c = el.innerText;
wryte.handlers.add_to_ignore_list_BANG_.call(null,c,w);

wryte.handlers.override_correction_BANG_.call(null,w,el);

return wryte.handlers.log.call(null,[cljs.core.str("Replaced "),cljs.core.str(c),cljs.core.str(" with "),cljs.core.str(w),cljs.core.str(".")].join(''));
});
/**
 * Event -> Void
 *   Changes the language to the chosen value
 */
wryte.handlers.on_change_language_chooser = (function wryte$handlers$on_change_language_chooser(event){
var lan = event.target.value;
cljs.core.println.call(null,lan);

wryte.db.set_language_BANG_.call(null,cljs.core.keyword.call(null,lan));

return wryte.speech_recognition.set_language_BANG_.call(null,cljs.core.deref.call(null,wryte.db.webspeech),wryte.db.locale.call(null));
});
wryte.handlers.on_start_recog = (function wryte$handlers$on_start_recog(){
cljs.core.swap_BANG_.call(null,wryte.db.app_db,cljs.core.assoc,new cljs.core.Keyword(null,"recording","recording",322996097),true);

if(cljs.core.not_EQ_.call(null,cljs.core.last.call(null,wryte.db.fresult.call(null)),new cljs.core.PersistentVector(null, 2, 5, cljs.core.PersistentVector.EMPTY_NODE, [new cljs.core.Keyword(null,"p","p",151049309),""], null))){
wryte.db.add_to_fresult_BANG_.call(null," ");
} else {
}

return cljs.core.println.call(null,"SPEAK NOW!");
});
wryte.handlers.on_error_recog = (function wryte$handlers$on_error_recog(event){
if(cljs.core._EQ_.call(null,event.error,"no-speech")){
cljs.core.println.call(null,"NO SPEECH");
} else {
}

if(cljs.core._EQ_.call(null,event.error,"audio-capture")){
cljs.core.println.call(null,"NO MICROPHONE");
} else {
}

if(cljs.core._EQ_.call(null,event.error,"not-allowed")){
cljs.core.println.call(null,"NOT ALLOWED");
} else {
}

return cljs.core.println.call(null,[cljs.core.str("speechRecognitionError: "),cljs.core.str(event.error)].join(''));
});
wryte.handlers.on_end_recog = (function wryte$handlers$on_end_recog(ev){
if(cljs.core.truth_((function (){var and__16437__auto__ = wryte.db.recording_QMARK_.call(null);
if(cljs.core.truth_(and__16437__auto__)){
return wryte.db.punc.call(null);
} else {
return and__16437__auto__;
}
})())){
wryte.handlers.log.call(null,[cljs.core.str("Recording: "),cljs.core.str(wryte.db.recording_QMARK_.call(null)),cljs.core.str(" Punctuation: "),cljs.core.str(wryte.db.punc.call(null))].join(''));

wryte.db.add_to_fresult_BANG_.call(null,wryte.db.punc.call(null));

wryte.db.reset_punc_BANG_.call(null);

cljs.core.println.call(null,wryte.db.punc.call(null));

return cljs.core.deref.call(null,wryte.db.webspeech).start();
} else {
if(cljs.core.not.call(null,wryte.db.checked_QMARK_.call(null))){
return wryte.handlers.send_to_languagetool.call(null,wryte.db.fresult__GT_string.call(null,wryte.db.fresult.call(null)));
} else {
return null;
}
}
});
wryte.handlers.on_result_recog = (function wryte$handlers$on_result_recog(event){
var results = event.results;
var length = results.length;
var i = cljs.core.atom.call(null,event.resultIndex);
cljs.core.swap_BANG_.call(null,wryte.db.app_db,cljs.core.assoc,new cljs.core.Keyword(null,"iresult","iresult",-774004111),"");

while(true){
if((cljs.core.deref.call(null,i) < length)){
if(cljs.core.truth_((results[cljs.core.deref.call(null,i)]).isFinal)){
wryte.db.add_to_fresult_BANG_.call(null,wryte.speech_recognition.sanitize.call(null,((results[cljs.core.deref.call(null,i)])[(0)]).transcript));
} else {
cljs.core.swap_BANG_.call(null,wryte.db.app_db,cljs.core.assoc,new cljs.core.Keyword(null,"iresult","iresult",-774004111),wryte.speech_recognition.sanitize.call(null,[cljs.core.str(new cljs.core.Keyword(null,"iresult","iresult",-774004111).cljs$core$IFn$_invoke$arity$1(cljs.core.deref.call(null,wryte.db.app_db))),cljs.core.str(((results[cljs.core.deref.call(null,i)])[(0)]).transcript)].join('')));
}

cljs.core.swap_BANG_.call(null,i,cljs.core.inc);

continue;
} else {
return null;
}
break;
}
});
/**
 * Changes final_result to user input
 */
wryte.handlers.on_blur_editor = (function wryte$handlers$on_blur_editor(event){
var innerHTML = event.target.innerHTML;
var hiccup = cljs.core.vec.call(null,cljs.core.first.call(null,cljs.core.map.call(null,hickory.core.as_hiccup,hickory.core.parse_fragment.call(null,innerHTML))));
cljs.core.println.call(null,hiccup);

return wryte.db.set_fresult_BANG_.call(null,hiccup);
});
/**
 * KeyEvent -> GlobalState
 *   Handles the keyevents that are created by js/document
 */
wryte.handlers.handle_keydown = (function wryte$handlers$handle_keydown(ev){
var mac_QMARK_ = ((cljs.core._EQ_.call(null,process.platform,"darwin"))?true:false);
var ky = ((function (mac_QMARK_){
return (function (p1__26593_SHARP_){
return p1__26593_SHARP_.keyCode;
});})(mac_QMARK_))
;
var ctrl_QMARK_ = ((mac_QMARK_)?((function (mac_QMARK_,ky){
return (function (p1__26594_SHARP_){
return p1__26594_SHARP_.metaKey;
});})(mac_QMARK_,ky))
:((function (mac_QMARK_,ky){
return (function (p1__26595_SHARP_){
return p1__26595_SHARP_.ctrlKey;
});})(mac_QMARK_,ky))
);
if((cljs.core.not.call(null,wryte.db.edit_QMARK_.call(null))) && (cljs.core._EQ_.call(null,ky.call(null,ev),(32)))){
return wryte.handlers.toggle_recording_BANG_.call(null,ev);
} else {
if(cljs.core.truth_(wryte.db.recording_QMARK_.call(null))){
if(cljs.core._EQ_.call(null,ky.call(null,ev),(13))){
cljs.core.deref.call(null,wryte.db.webspeech).stop();

wryte.db.set_pgraph_BANG_.call(null);

return ev.preventDefault();
} else {
if((cljs.core._EQ_.call(null,ky.call(null,ev),(38))) || (cljs.core._EQ_.call(null,ky.call(null,ev),(190)))){
cljs.core.deref.call(null,wryte.db.webspeech).stop();

return wryte.db.set_colon_BANG_.call(null);
} else {
if((cljs.core._EQ_.call(null,ky.call(null,ev),(40))) || (cljs.core._EQ_.call(null,ky.call(null,ev),(188)))){
cljs.core.deref.call(null,wryte.db.webspeech).stop();

return wryte.db.set_comma_BANG_.call(null);
} else {
if(cljs.core.truth_((function (){var or__16449__auto__ = cljs.core._EQ_.call(null,ky.call(null,ev),(9));
if(or__16449__auto__){
return or__16449__auto__;
} else {
var and__16437__auto__ = cljs.core._EQ_.call(null,ky.call(null,ev),(188));
if(and__16437__auto__){
return ev.shift;
} else {
return and__16437__auto__;
}
}
})())){
cljs.core.deref.call(null,wryte.db.webspeech).stop();

return wryte.db.set_dquote_BANG_.call(null);
} else {
return null;
}
}
}
}
} else {
return null;
}
}
});
/**
 * ClickEvent -> GlobalState
 *   Handles the clickevents that are created by js/document
 */
wryte.handlers.handle_click = (function wryte$handlers$handle_click(ev){
var el = ev.target;
var className = el.className;
if(!((cljs.core._EQ_.call(null,"SPAN",el.nodeName)) && (cljs.core.contains_QMARK_.call(null,new cljs.core.PersistentHashSet(null, new cljs.core.PersistentArrayMap(null, 2, ["error",null,"ignored",null], null), null),className)))){
return false;
} else {
wryte.handlers.log.call(null,ev);

var menu = (new wryte.handlers.MENU());
if(cljs.core._EQ_.call(null,className,"error")){
menu.append((new wryte.handlers.MENUITEM(cljs.core.clj__GT_js.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"label","label",1718410804),"Alternatives",new cljs.core.Keyword(null,"enabled","enabled",1195909756),false], null)))));

wryte.handlers.add_alternatives_BANG_.call(null,clojure.string.split.call(null,el.dataset.alternatives,/,/),el,menu,wryte.handlers.on_click_context_menu_item);

menu.append((new wryte.handlers.MENUITEM(cljs.core.clj__GT_js.call(null,new cljs.core.PersistentArrayMap(null, 1, [new cljs.core.Keyword(null,"type","type",1174270348),"separator"], null)))));
} else {
}

menu.append((new wryte.handlers.MENUITEM(cljs.core.clj__GT_js.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"label","label",1718410804),"Replaced",new cljs.core.Keyword(null,"enabled","enabled",1195909756),false], null)))));

menu.append((new wryte.handlers.MENUITEM(cljs.core.clj__GT_js.call(null,new cljs.core.PersistentArrayMap(null, 2, [new cljs.core.Keyword(null,"label","label",1718410804),el.dataset.replaced,new cljs.core.Keyword(null,"click","click",1912301393),((function (menu,el,className){
return (function (){
return wryte.handlers.on_click_context_menu_item.call(null,el.dataset.replaced,el);
});})(menu,el,className))
], null)))));

return menu.popup(wryte.handlers.remote.getCurrentWindow());
}
});
/**
 * Register the keyhandlers
 */
wryte.handlers.register_keyevents = (function wryte$handlers$register_keyevents(){
return goog.events.listen(window,"keydown",wryte.handlers.handle_keydown);
});
/**
 * Register the moushandlers
 */
wryte.handlers.register_mousevents = (function wryte$handlers$register_mousevents(){
return goog.events.listen(window,"click",wryte.handlers.handle_click);
});
wryte.handlers.setup_webspeech = (function wryte$handlers$setup_webspeech(){
var recog = wryte.speech_recognition.setup.call(null,wryte.handlers.on_start_recog,wryte.handlers.on_error_recog,wryte.handlers.on_end_recog,wryte.handlers.on_result_recog,wryte.db.locale.call(null));
return cljs.core.reset_BANG_.call(null,wryte.db.webspeech,recog);
});
wryte.handlers.setup_editor = (function wryte$handlers$setup_editor(){
return true;
});

//# sourceMappingURL=handlers.js.map